Index: svn/src/mainboard/tyan/s2912_fam10/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s2912_fam10/devicetree.cb
+++ svn/src/mainboard/tyan/s2912_fam10/devicetree.cb
@@ -112,9 +112,7 @@ chip northbridge/amd/amdfam10/root_compl
 					device pci 5.1 on end # SATA 1
 					device pci 5.2 on end # SATA 2
 					device pci 6.0 on
-						chip drivers/pci/onboard
-							device pci 4.0 on end
-						end
+						device pci 4.0 on end
 					end # PCI
 					device pci 6.1 off end # AZA
 					device pci 8.0 on end # NIC
Index: svn/src/mainboard/tyan/s4880/Config.lb
===================================================================
--- svn.orig/src/mainboard/tyan/s4880/Config.lb
+++ svn/src/mainboard/tyan/s4880/Config.lb
@@ -116,10 +116,8 @@ chip northbridge/amd/amdk8/root_complex
 #                                                        device pci 4.1 on end
 #                                                        register "fw_address" = "0xfff8c000"
 #                                                end
-                                                chip drivers/pci/onboard
-                                                        device pci 9.0 on end
-                                                        device pci 9.1 on end
-                                                end
+                                                device pci 9.0 on end
+                                                device pci 9.1 on end
 					end
 					device pci 0.1 on end
 					device pci 1.0 on end
@@ -133,9 +131,7 @@ chip northbridge/amd/amdk8/root_complex
 						device pci 0.1 on end
 						device pci 0.2 off end
 						device pci 1.0 off end
-                                                chip drivers/pci/onboard
-                                                        device pci 6.0 on end
-                                                end
+                                                device pci 6.0 on end
 					end
 					device pci 1.0 on
 						chip superio/winbond/w83627hf
Index: svn/src/mainboard/tyan/s4880/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s4880/devicetree.cb
+++ svn/src/mainboard/tyan/s4880/devicetree.cb
@@ -19,10 +19,8 @@ chip northbridge/amd/amdk8/root_complex
 #                                                        device pci 4.1 on end
 #                                                        register "fw_address" = "0xfff8c000"
 #                                                end
-                                                chip drivers/pci/onboard
-                                                        device pci 9.0 on end
-                                                        device pci 9.1 on end
-                                                end
+                                                device pci 9.0 on end
+                                                device pci 9.1 on end
 					end
 					device pci 0.1 on end
 					device pci 1.0 on end
@@ -36,9 +34,7 @@ chip northbridge/amd/amdk8/root_complex
 						device pci 0.1 on end
 						device pci 0.2 off end
 						device pci 1.0 off end
-                                                chip drivers/pci/onboard
-                                                        device pci 6.0 on end
-                                                end
+                                                device pci 6.0 on end
 					end
 					device pci 1.0 on
 						chip superio/winbond/w83627hf
Index: svn/src/mainboard/tyan/s4882/Config.lb
===================================================================
--- svn.orig/src/mainboard/tyan/s4882/Config.lb
+++ svn/src/mainboard/tyan/s4882/Config.lb
@@ -114,10 +114,8 @@ chip northbridge/amd/amdk8/root_complex
 #							device pci 4.1 on end
 #							register "fw_address" = "0xfff8c000"
 #						end
-                                                chip drivers/pci/onboard
-                                                        device pci 9.0 on end #Broadcom
-                                                        device pci 9.1 on end
-                                                end 
+                                                device pci 9.0 on end #Broadcom
+                                                device pci 9.1 on end
 					end
 					device pci 0.1 on end
 					device pci 1.0 on end
@@ -132,12 +130,9 @@ chip northbridge/amd/amdk8/root_complex
 						device pci 0.2 off end
 						device pci 1.0 off end
                                                 #chip drivers/ati/ragexl
-                                                chip drivers/pci/onboard
-                                                        device pci 6.0 on end
-                                                end
-                                                chip drivers/pci/onboard
-                                                        device pci 5.0 on end #SiI
-                                                end
+                                                device pci 6.0 on end
+                                                #end
+                                                device pci 5.0 on end #SiI
 					end
 					device pci 1.0 on
 						chip superio/winbond/w83627hf
Index: svn/src/mainboard/tyan/s4882/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s4882/devicetree.cb
+++ svn/src/mainboard/tyan/s4882/devicetree.cb
@@ -17,10 +17,8 @@ chip northbridge/amd/amdk8/root_complex
 #							device pci 4.1 on end
 #							register "fw_address" = "0xfff8c000"
 #						end
-                                                chip drivers/pci/onboard
-                                                        device pci 9.0 on end #Broadcom
-                                                        device pci 9.1 on end
-                                                end 
+                                                device pci 9.0 on end #Broadcom
+                                                device pci 9.1 on end
 					end
 					device pci 0.1 on end
 					device pci 1.0 on end
@@ -35,12 +33,9 @@ chip northbridge/amd/amdk8/root_complex
 						device pci 0.2 off end
 						device pci 1.0 off end
                                                 #chip drivers/ati/ragexl
-                                                chip drivers/pci/onboard
-                                                        device pci 6.0 on end
-                                                end
-                                                chip drivers/pci/onboard
-                                                        device pci 5.0 on end #SiI
-                                                end
+                                                device pci 6.0 on end
+                                                #end
+                                                device pci 5.0 on end #SiI
 					end
 					device pci 1.0 on
 						chip superio/winbond/w83627hf
Index: svn/src/mainboard/via/vt8454c/Config.lb
===================================================================
--- svn.orig/src/mainboard/via/vt8454c/Config.lb
+++ svn/src/mainboard/via/vt8454c/Config.lb
@@ -121,9 +121,7 @@ chip northbridge/via/cx700
 		device pci 0.4 on end # Power Management
 		device pci 0.7 on end # V-Link Controller
 		device pci 1.0 on     # PCI Bridge
-			chip drivers/pci/onboard
-				device pci 0.0 on end
-			end # Onboard Video
+			device pci 0.0 on end # Onboard Video
 		end # PCI Bridge
 		device pci f.0 on end # IDE/SATA
 		#device pci f.1 on end # IDE
Index: svn/src/mainboard/via/vt8454c/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/via/vt8454c/devicetree.cb
+++ svn/src/mainboard/via/vt8454c/devicetree.cb
@@ -12,9 +12,7 @@ chip northbridge/via/cx700
 		device pci 0.4 on end # Power Management
 		device pci 0.7 on end # V-Link Controller
 		device pci 1.0 on     # PCI Bridge
-			chip drivers/pci/onboard
-				device pci 0.0 on end
-			end # Onboard Video
+			device pci 0.0 on end # Onboard Video
 		end # PCI Bridge
 		device pci f.0 on end # IDE/SATA
 		#device pci f.1 on end # IDE
Index: svn/src/devices/pci_device.c
===================================================================
--- svn.orig/src/devices/pci_device.c
+++ svn/src/devices/pci_device.c
@@ -285,11 +285,6 @@ static void pci_get_rom_resource(struct 
 	unsigned long value;
 	resource_t moving;
 
-	if ((dev->on_mainboard) && (dev->rom_address == 0)) {
-		/* Skip it if rom_address is not set in the MB Config.lb. */
-		return;
-	}
-
 	/* Initialize the resources to nothing. */
 	resource = new_resource(dev, index);
 
@@ -326,18 +321,6 @@ static void pci_get_rom_resource(struct 
 		}
 		resource->flags = 0;
 	}
-
-	/* For on board device with embedded ROM image, the ROM image is at
-	 * fixed address specified in the Config.lb, the dev->rom_address is
-	 * inited by driver_pci_onboard_ops::enable_dev() */
-	if ((dev->on_mainboard) && (dev->rom_address != 0)) {
-		resource->base = dev->rom_address;
-		/* The resource allocator needs the size to be non-zero. */
-		resource->size = 0x100;
-		resource->flags |= IORESOURCE_MEM | IORESOURCE_READONLY |
-		    IORESOURCE_ASSIGNED | IORESOURCE_FIXED;
-	}
-
 	compact_resources(dev);
 }
 
Index: svn/src/devices/pci_rom.c
===================================================================
--- svn.orig/src/devices/pci_rom.c
+++ svn/src/devices/pci_rom.c
@@ -31,42 +31,37 @@
 
 struct rom_header * pci_rom_probe(struct device *dev)
 {
-	unsigned long rom_address = 0;
 	struct rom_header *rom_header;
 	struct pci_data *rom_data;
 
-	void *v;
-	/* if it's in FLASH, then it's as if dev->on_mainboard was true */
-	v = cbfs_load_optionrom(dev->vendor, dev->device, NULL);
-	printk_debug("In cbfs, rom address for %s = %p\n", 
-			dev_path(dev), v);
-	if (v) {
-		dev->rom_address = (u32)v;
-		dev->on_mainboard = 1;
-	}
+	/* If it's in FLASH, then don't check device for ROM. */
+	rom_header = cbfs_load_optionrom(dev->vendor, dev->device, NULL);
 
-	if (dev->on_mainboard) {
-                // in case some device PCI_ROM_ADDRESS can not be set or readonly 
-		rom_address = dev->rom_address;
-		printk_debug("On mainboard, rom address for %s = %lx\n", 
-			dev_path(dev), rom_address);
+	if (rom_header) {
+		printk_debug("In cbfs, rom address for %s = %p\n",
+			     dev_path(dev), rom_header);
 	} else {
+		unsigned long rom_address;
+
 		rom_address = pci_read_config32(dev, PCI_ROM_ADDRESS);
-		printk_debug("On card, rom address for %s = %lx\n", 
-				dev_path(dev), rom_address);
-	}
 
-	if (rom_address == 0x00000000 || rom_address == 0xffffffff) {
-		return NULL;
-	}
+		if (rom_address == 0x00000000 || rom_address == 0xffffffff) {
+			#if CONFIG_BOARD_EMULATION_QEMU_X86
+			rom_address = 0xc0000;
+			#else
+			return NULL;
+			#endif
+		} else {
+			/* enable expansion ROM address decoding */
+			pci_write_config32(dev, PCI_ROM_ADDRESS,
+					   rom_address|PCI_ROM_ADDRESS_ENABLE);
+		}
 
-	if(!dev->on_mainboard) {
-		/* enable expansion ROM address decoding */
-		pci_write_config32(dev, PCI_ROM_ADDRESS,
-				   rom_address|PCI_ROM_ADDRESS_ENABLE);
+		printk_debug("On card, rom address for %s = %lx\n",
+				dev_path(dev), rom_address);
+		rom_header = (struct rom_header *)rom_address;
 	}
 
-	rom_header = (struct rom_header *)rom_address;
 	printk_spew("PCI Expansion ROM, signature 0x%04x, INIT size 0x%04x, data ptr 0x%04x\n",
 		    le32_to_cpu(rom_header->signature),
 		    rom_header->size * 512, le32_to_cpu(rom_header->data));
@@ -76,11 +71,12 @@ struct rom_header * pci_rom_probe(struct
 		return NULL;
 	}
 
-	rom_data = (struct pci_data *) ((void *)rom_header + le32_to_cpu(rom_header->data));
+	rom_data = (((void *)rom_header) + le32_to_cpu(rom_header->data));
+
 	printk_spew("PCI ROM Image, Vendor %04x, Device %04x,\n",
 		    rom_data->vendor, rom_data->device);
 	if (dev->vendor != rom_data->vendor || dev->device != rom_data->device) {
-		printk_err("Device or Vendor ID mismatch Vendor %04x, Device %04x\n",
+		printk_err("ID mismatch: Vendor ID %04x, Device ID %04x\n",
 			   rom_data->vendor, rom_data->device);
 		return NULL;
 	}
@@ -90,7 +86,8 @@ struct rom_header * pci_rom_probe(struct
 		    rom_data->type);
 	if (dev->class != ((rom_data->class_hi << 8) | rom_data->class_lo)) {
 		printk_debug("Class Code mismatch ROM %08x, dev %08x\n", 
-			    (rom_data->class_hi << 8) | rom_data->class_lo, dev->class);
+			     (rom_data->class_hi << 8) | rom_data->class_lo,
+			     dev->class);
 		//return NULL;
 	}
 
Index: svn/src/mainboard/hp/dl145_g3/Config.lb
===================================================================
--- svn.orig/src/mainboard/hp/dl145_g3/Config.lb
+++ svn/src/mainboard/hp/dl145_g3/Config.lb
@@ -195,15 +195,6 @@ chip northbridge/amd/amdk8/root_complex
 					device pci 2.1 on end # USB
 					device pci 2.2 on end # USB
 					device pci 3.0 on end # VGA
-					
-					#bx_a013+ start
-					#chip drivers/pci/onboard    #SATA2
-					#	device pci 5.0 on end
-					#	device pci 5.1 on end
-					#	device pci 5.2 on end
-					#	device pci 5.3 on end
-					#end
-					#bx_a013+ end
 				end
 			end
 			device pci 18.0 on end
Index: svn/src/mainboard/hp/dl145_g3/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/hp/dl145_g3/devicetree.cb
+++ svn/src/mainboard/hp/dl145_g3/devicetree.cb
@@ -72,15 +72,6 @@ chip northbridge/amd/amdk8/root_complex
 					device pci 2.1 on end # USB
 					device pci 2.2 on end # USB
 					device pci 3.0 on end # VGA
-					
-					#bx_a013+ start
-					#chip drivers/pci/onboard    #SATA2
-					#	device pci 5.0 on end
-					#	device pci 5.1 on end
-					#	device pci 5.2 on end
-					#	device pci 5.3 on end
-					#end
-					#bx_a013+ end
 				end
 			end
 			device pci 18.0 on end
Index: svn/src/mainboard/intel/xe7501devkit/Config.lb
===================================================================
--- svn.orig/src/mainboard/intel/xe7501devkit/Config.lb
+++ svn/src/mainboard/intel/xe7501devkit/Config.lb
@@ -127,9 +127,7 @@ chip northbridge/intel/e7501
 			device pci 1d.1 off end # USB (not populated)
 			device pci 1d.2 off end # USB (not populated)
 			device pci 1e.0 on # Hub to PCI bridge
-				chip drivers/pci/onboard # VGA ROM
-					device pci 0.0 on end
-				end
+				device pci 0.0 on end
 			end
 			device pci 1f.0 on # LPC bridge
 				chip superio/smsc/lpc47b272
Index: svn/src/mainboard/intel/xe7501devkit/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/intel/xe7501devkit/devicetree.cb
+++ svn/src/mainboard/intel/xe7501devkit/devicetree.cb
@@ -25,9 +25,7 @@ chip northbridge/intel/e7501
 			device pci 1d.1 off end # USB (not populated)
 			device pci 1d.2 off end # USB (not populated)
 			device pci 1e.0 on # Hub to PCI bridge
-				chip drivers/pci/onboard # VGA ROM
-					device pci 0.0 on end
-				end
+				device pci 0.0 on end
 			end
 			device pci 1f.0 on # LPC bridge
 				chip superio/smsc/lpc47b272
Index: svn/src/mainboard/newisys/khepri/Config.lb
===================================================================
--- svn.orig/src/mainboard/newisys/khepri/Config.lb
+++ svn/src/mainboard/newisys/khepri/Config.lb
@@ -98,8 +98,6 @@ end
 
 config chip.h
 
-# FIXME: ROM for onboard VGA
-
 chip northbridge/amd/amdk8/root_complex
 	device apic_cluster 0 on
 		chip cpu/amd/socket_940
Index: svn/src/mainboard/tyan/s2735/Config.lb
===================================================================
--- svn.orig/src/mainboard/tyan/s2735/Config.lb
+++ svn/src/mainboard/tyan/s2735/Config.lb
@@ -100,10 +100,8 @@ chip northbridge/intel/e7501
         		chip southbridge/intel/i82870
         	        	device pci 1c.0 on end
 		                device pci 1d.0 on 
-					chip drivers/pci/onboard
-                                        	device pci 1.0 on end # intel lan
-                                                device pci 1.1 on end
-                                        end
+                                     	 device pci 1.0 on end # intel lan
+                                        device pci 1.1 on end
 				end
         	                device pci 1e.0 on end
         	                device pci 1f.0 on end
@@ -117,12 +115,8 @@ chip northbridge/intel/e7501
         	        device pci 1d.3 on end
 		        device pci 1d.7 on end
 		        device pci 1e.0 on 
-                        	chip drivers/pci/onboard
-                                	device pci 1.0 on end # intel lan 10/100
-                                end
-                                chip drivers/pci/onboard
-                                        device pci 2.0 on end # ati 
-                                end
+                             	device pci 1.0 on end # intel lan 10/100
+                                device pci 2.0 on end # ati
 			end
 		        device pci 1f.0 on
 				chip superio/winbond/w83627hf
Index: svn/src/mainboard/tyan/s2735/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s2735/devicetree.cb
+++ svn/src/mainboard/tyan/s2735/devicetree.cb
@@ -6,10 +6,8 @@ chip northbridge/intel/e7501
         		chip southbridge/intel/i82870
         	        	device pci 1c.0 on end
 		                device pci 1d.0 on 
-					chip drivers/pci/onboard
-                                        	device pci 1.0 on end # intel lan
-                                                device pci 1.1 on end
-                                        end
+                                     	 device pci 1.0 on end # intel lan
+                                        device pci 1.1 on end
 				end
         	                device pci 1e.0 on end
         	                device pci 1f.0 on end
@@ -23,12 +21,8 @@ chip northbridge/intel/e7501
         	        device pci 1d.3 on end
 		        device pci 1d.7 on end
 		        device pci 1e.0 on 
-                        	chip drivers/pci/onboard
-                                	device pci 1.0 on end # intel lan 10/100
-                                end
-                                chip drivers/pci/onboard
-                                        device pci 2.0 on end # ati 
-                                end
+                             	device pci 1.0 on end # intel lan 10/100
+                                device pci 2.0 on end # ati
 			end
 		        device pci 1f.0 on
 				chip superio/winbond/w83627hf
Index: svn/src/mainboard/tyan/s2885/Config.lb
===================================================================
--- svn.orig/src/mainboard/tyan/s2885/Config.lb
+++ svn/src/mainboard/tyan/s2885/Config.lb
@@ -121,9 +121,7 @@ chip northbridge/amd/amdk8/root_complex
 				chip southbridge/amd/amd8131
 					# the on/off keyword is mandatory
 					device pci 0.0 on 
-                                                chip drivers/pci/onboard
-                                                        device pci 9.0 on end # broadcom 5703
-                                                end
+                                                device pci 9.0 on end # broadcom 5703
 					end
 					device pci 0.1 on end
 					device pci 1.0 on end
@@ -137,9 +135,7 @@ chip northbridge/amd/amdk8/root_complex
 						device pci 0.1 on end
 						device pci 0.2 off end
 						device pci 1.0 off end
-                                                chip drivers/pci/onboard
-                                                        device pci b.0 on end # SiI 3114
-                                                end
+                                                device pci b.0 on end # SiI 3114
 					end
 					device pci 1.0 on
 						chip superio/winbond/w83627hf
Index: svn/src/mainboard/tyan/s2885/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s2885/devicetree.cb
+++ svn/src/mainboard/tyan/s2885/devicetree.cb
@@ -19,9 +19,7 @@ chip northbridge/amd/amdk8/root_complex
 				chip southbridge/amd/amd8131
 					# the on/off keyword is mandatory
 					device pci 0.0 on 
-                                                chip drivers/pci/onboard
-                                                        device pci 9.0 on end # broadcom 5703
-                                                end
+                                                device pci 9.0 on end # broadcom 5703
 					end
 					device pci 0.1 on end
 					device pci 1.0 on end
@@ -35,9 +33,7 @@ chip northbridge/amd/amdk8/root_complex
 						device pci 0.1 on end
 						device pci 0.2 off end
 						device pci 1.0 off end
-                                                chip drivers/pci/onboard
-                                                        device pci b.0 on end # SiI 3114
-                                                end
+                                                device pci b.0 on end # SiI 3114
 					end
 					device pci 1.0 on
 						chip superio/winbond/w83627hf
Index: svn/src/mainboard/tyan/s2891/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s2891/devicetree.cb
+++ svn/src/mainboard/tyan/s2891/devicetree.cb
@@ -104,9 +104,7 @@ chip northbridge/amd/amdk8/root_complex
 					device pci 8.0 on end # SATA 0
 					device pci 9.0 on  # PCI
 					#	chip drivers/ati/ragexl
-						chip drivers/pci/onboard
-							device pci 7.0 on end
-						end
+						device pci 7.0 on end
 					end
 					device pci a.0 off end # NIC
 					device pci b.0 off end # PCI E 3
@@ -127,10 +125,8 @@ chip northbridge/amd/amdk8/root_complex
 					device pci 0.0 on end
 					device pci 0.1 on end
 					device pci 1.0 on
-						chip drivers/pci/onboard
-							device pci 9.0 on end
-							device pci 9.1 on end
-						end
+						device pci 9.0 on end
+						device pci 9.1 on end
 					end
 					device pci 1.1 on end
 				end
Index: svn/src/mainboard/tyan/s2892/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s2892/devicetree.cb
+++ svn/src/mainboard/tyan/s2892/devicetree.cb
@@ -105,12 +105,9 @@ chip northbridge/amd/amdk8/root_complex
 					device pci 8.0 on end # SATA 0
 					device pci 9.0 on  # PCI
 					#	chip drivers/ati/ragexl
-						chip drivers/pci/onboard
-							device pci 6.0 on end
-						end
-						chip drivers/pci/onboard
-							device pci 8.0 on end
-						end
+						device pci 6.0 on end
+					#	end
+						device pci 8.0 on end
 					end
 					device pci a.0 off end # NIC
 					device pci b.0 off end # PCI E 3
@@ -131,10 +128,8 @@ chip northbridge/amd/amdk8/root_complex
 					device pci 0.0 on end
 					device pci 0.1 on end
 					device pci 1.0 on
-						chip drivers/pci/onboard
-							device pci 9.0 on end # broadcom 5704
-							device pci 9.1 on end
-						end
+						device pci 9.0 on end # broadcom 5704
+						device pci 9.1 on end
 					end
 					device pci 1.1 on end
 				end
Index: svn/src/mainboard/tyan/s2895/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/tyan/s2895/devicetree.cb
+++ svn/src/mainboard/tyan/s2895/devicetree.cb
@@ -111,10 +111,8 @@ chip northbridge/amd/amdk8/root_complex
 					device pci 0.0 on end
 					device pci 0.1 on end
 					device pci 1.0 on
-						chip drivers/pci/onboard
-							device pci 6.0 on end # lsi scsi
-							device pci 6.1 on end
-						end
+						device pci 6.0 on end # lsi scsi
+						device pci 6.1 on end
 					end
 					device pci 1.1 on end
 				end
Index: svn/src/mainboard/via/epia/Config.lb
===================================================================
--- svn.orig/src/mainboard/via/epia/Config.lb
+++ svn/src/mainboard/via/epia/Config.lb
@@ -96,10 +96,7 @@ chip northbridge/via/vt8601
 	device pci_domain 0 on
     		device pci 0.0 on end			# Northbridge
 #		device pci 0.1 on			# AGP bridge
-		#	chip drivers/pci/onboard	# Integrated VGA
-		#		device pci 0.0 on end
-		#		register "rom_adress" = "0xfff80000"
-		#	end
+		#	device pci 0.0 on end		# Integrated VGA
 #		end
 		chip southbridge/via/vt8231
 			register "enable_native_ide" = "0"
Index: svn/src/mainboard/via/epia/devicetree.cb
===================================================================
--- svn.orig/src/mainboard/via/epia/devicetree.cb
+++ svn/src/mainboard/via/epia/devicetree.cb
@@ -2,10 +2,7 @@ chip northbridge/via/vt8601
 	device pci_domain 0 on
     		device pci 0.0 on end			# Northbridge
 #		device pci 0.1 on			# AGP bridge
-		#	chip drivers/pci/onboard	# Integrated VGA
-		#		device pci 0.0 on end
-		#		register "rom_adress" = "0xfff80000"
-		#	end
+		#	device pci 0.0 on end		# Integrated VGA
 #		end
 		chip southbridge/via/vt8231
 			register "enable_native_ide" = "0"
Index: svn/src/southbridge/nvidia/ck804/chip.h
===================================================================
--- svn.orig/src/southbridge/nvidia/ck804/chip.h
+++ svn/src/southbridge/nvidia/ck804/chip.h
@@ -7,8 +7,6 @@ struct southbridge_nvidia_ck804_config {
 	unsigned int ide1_enable : 1;
 	unsigned int sata0_enable : 1;
 	unsigned int sata1_enable : 1;
-	unsigned long nic_rom_address;
-	unsigned long raid_rom_address;
 	unsigned int mac_eeprom_smbus;
 	unsigned int mac_eeprom_addr;
 };
Index: svn/src/southbridge/nvidia/ck804/ck804.c
===================================================================
--- svn.orig/src/southbridge/nvidia/ck804/ck804.c
+++ svn/src/southbridge/nvidia/ck804/ck804.c
@@ -77,12 +77,10 @@ void ck804_enable(device_t dev)
 	case PCI_DEVICE_ID_NVIDIA_CK804_NIC:
 		devfn -= (9 << 3);
 		index = 10;
-		dev->rom_address = conf->nic_rom_address;
 		break;
 	case PCI_DEVICE_ID_NVIDIA_CK804_NIC_BRIDGE:
 		devfn -= (9 << 3);
 		index = 10;
-		dev->rom_address = conf->nic_rom_address;
 		break;
 	case PCI_DEVICE_ID_NVIDIA_CK804_ACI:
 		devfn -= (3 << 3);
@@ -95,7 +93,6 @@ void ck804_enable(device_t dev)
 	case PCI_DEVICE_ID_NVIDIA_CK804_IDE:
 		devfn -= (5 << 3);
 		index = 14;
-		dev->rom_address = conf->raid_rom_address;
 		break;
 	case PCI_DEVICE_ID_NVIDIA_CK804_SATA0:
 		devfn -= (6 << 3);
Index: svn/src/mainboard/artecgroup/dbe61/realmode/vgabios.c
===================================================================
--- svn.orig/src/mainboard/artecgroup/dbe61/realmode/vgabios.c
+++ svn/src/mainboard/artecgroup/dbe61/realmode/vgabios.c
@@ -74,36 +74,6 @@
   emulator to successfully run this bios.
 */
 
-
-
-
-/*
-  Modified to be an universal driver for loading VGA ROMs.
-  Aug 2006, anti.sullin@artecdesign.ee, Artec Design
-  
-  USAGE:
-  	define in your motherboard Config.lb file in device hierarchy 
-  	around the VGA pci device realmode chip and define its rom address.
-	Rom address is read from Config.lb, this rom is then copied to 0xC000 and then excecuted
-  	
-  		chip drivers/pci/realmode
-				device pci 1.1 on end  					# VGA
-				register "rom_address" = "0xfffc0000"	# at the beginning of 256k
-		end
-  	
-  	then, chip enable is called at this list first traversal, and this sets
-  	up device's init callback. Device init is called during last list traversal and
-  	so, other hw should be already initialized to run vga bios successfully.
-*/
-
-
-
-
-
-
-
-
-
 /* Declare a temporary global descriptor table - necessary because the
    Core part of the bios no longer sets up any 16 bit segments */
 __asm__ (
@@ -918,8 +888,6 @@ static void vga_init(device_t dev)
 
 	// code to make vga init go through the emulator - as of yet this does not workfor the epia-m
 	dev->on_mainboard=1;
-	dev->rom_address = (void *)cfg->rom_address;
-
 	pci_dev_init(dev);
 
 	// code to make vga init run in real mode - does work but against the current coreboot philosophy 
Index: svn/src/mainboard/emulation/qemu-x86/mainboard.c
===================================================================
--- svn.orig/src/mainboard/emulation/qemu-x86/mainboard.c
+++ svn/src/mainboard/emulation/qemu-x86/mainboard.c
@@ -16,7 +16,6 @@ static void qemu_init(device_t dev)
 	 * force coreboot to use it.
 	 */
 	dev->on_mainboard = 1;
-	dev->rom_address = 0xc0000;
 
 	/* Now do the usual initialization */
 	pci_dev_init(dev);
Index: svn/src/northbridge/via/cn400/vga.c
===================================================================
--- svn.orig/src/northbridge/via/cn400/vga.c
+++ svn/src/northbridge/via/cn400/vga.c
@@ -121,15 +121,8 @@ static void vga_init(device_t dev)
 #endif
 }
 
-static void vga_read_resources(device_t dev)
-{
-	dev->rom_address = 0xfff80000;
-	dev->on_mainboard = 1;
-	pci_dev_read_resources(dev);
-}
-
 static const struct device_operations vga_operations = {
-	.read_resources   = vga_read_resources,
+	.read_resources   = pci_dev_read_resources,
 	.set_resources    = pci_dev_set_resources,
 	.enable_resources = pci_dev_enable_resources,
 	.init             = vga_init,
Index: svn/src/northbridge/via/cn700/vga.c
===================================================================
--- svn.orig/src/northbridge/via/cn700/vga.c
+++ svn/src/northbridge/via/cn700/vga.c
@@ -101,15 +101,8 @@ static void vga_init(device_t dev)
 	memset(0xf0000, 0, 0x10000);
 }
 
-static void vga_read_resources(device_t dev)
-{
-	dev->rom_address = 0xfff80000;
-	dev->on_mainboard = 1;
-	pci_dev_read_resources(dev);
-}
-
 static const struct device_operations vga_operations = {
-	.read_resources   = vga_read_resources,
+	.read_resources   = pci_dev_read_resources,
 	.set_resources    = pci_dev_set_resources,
 	.enable_resources = pci_dev_enable_resources,
 	.init             = vga_init,
Index: svn/src/northbridge/via/cx700/cx700_vga.c
===================================================================
--- svn.orig/src/northbridge/via/cx700/cx700_vga.c
+++ svn/src/northbridge/via/cx700/cx700_vga.c
@@ -97,15 +97,8 @@ static void vga_init(device_t dev)
 	outb(reg8, SR_DATA);
 }
 
-static void vga_read_resources(device_t dev)
-{
-	dev->rom_address = 0xfff80000;
-	dev->on_mainboard = 1;
-	pci_dev_read_resources(dev);
-}
-
 static struct device_operations vga_operations = {
-	.read_resources = vga_read_resources,
+	.read_resources = pci_dev_read_resources,
 	.set_resources = pci_dev_set_resources,
 	.enable_resources = pci_dev_enable_resources,
 	.init = vga_init,
Index: svn/src/northbridge/via/vt8623/northbridge.c
===================================================================
--- svn.orig/src/northbridge/via/vt8623/northbridge.c
+++ svn/src/northbridge/via/vt8623/northbridge.c
@@ -124,9 +124,6 @@ static void vga_init(device_t dev)
 	
 #if 0
 	/* code to make vga init go through the emulator - as of yet this does not workfor the epia-m */
-	dev->on_mainboard=1;
-	dev->rom_address = (void *)0xfffc0000;
-
 	pci_dev_init(dev);
 	
 	call_bios_interrupt(0x10,0x4f1f,0x8003,1,0);
@@ -167,17 +164,8 @@ static void vga_init(device_t dev)
 #endif
 }
 
-static void vga_read_resources(device_t dev)
-{
-
-	dev->rom_address = (void *)0xfffc0000;
-	dev->on_mainboard=1;
-	pci_dev_read_resources(dev);
-
-}
-
 static struct device_operations vga_operations = {
-	.read_resources   = vga_read_resources,
+	.read_resources   = pci_dev_read_resources,
 	.set_resources    = pci_dev_set_resources,
 	.enable_resources = pci_dev_enable_resources,
 	.init             = vga_init,
